//+------------------------------------------------------------------+
//|                                              Brooky_Chaos_MA.mq4 |
//|                                          Copyright  2010,Brooky |
//|                               http://forex-indicators.weebly.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010,Brooky"
#property link      "http://forex-indicators.weebly.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Orange
#property indicator_color2 DodgerBlue
//---- input parameters
extern string    Author_Site = "forex-indicators.weebly.com";
extern string    Note_1 = "Period Both MAs Use";
extern int       Smooth_Period=14;
extern string    Note_2 = "Set Shift to 0 if non desired";
extern int       Data_Shift=0;
extern int       Smooth_Shift=0;
extern string    Note_3 = "Data Stimulation";
extern bool      Use_Champernowne_Stimulation = False;
extern bool      Use_Fibonacci_Stimulation = True;
//---- buffers
double main_line[];
double smooth_line[];
double main_data[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexBuffer(0,main_line);SetIndexStyle(0,DRAW_LINE);SetIndexShift(0,Smooth_Shift);
   SetIndexBuffer(1,smooth_line);SetIndexStyle(1,DRAW_LINE);SetIndexShift(1,Data_Shift);
   SetIndexBuffer(2,main_data);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  int start()
    {
     int limit;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
  //---- main loop
     for(int i=0; i<limit; i++)
       {
        main_line[i] =iMA(NULL,0,Smooth_Period,0,MODE_LWMA,PRICE_LOW,i);
       double stimulator = 1;
       if(Use_Champernowne_Stimulation)stimulator = 1.2345678910;
       if(Use_Fibonacci_Stimulation)stimulator = 1.6180339887;
       
       
       string value0=DoubleToStr((iClose(NULL,0,i)/100)*stimulator, 12);
         string subvalue0=StringSubstr(value0, 2, 12);
         string subvalue0chop=StringSubstr(value0, 0, 1);
         int subvalue0chop2dble=StrToDouble(subvalue0chop);
            double subvalue_double0=StrToDouble(subvalue0)/100000000;
            
       string value1=DoubleToStr(subvalue_double0*10, 12);
         string subvalue1=StringSubstr(value1, 2, 12);
         string subvalue1chop=StringSubstr(value1, 0, 1);
         int subvalue1chop2dble=StrToDouble(subvalue1chop);
            double subvalue_double1=StrToDouble(subvalue1)/100000000;
                        
       string value2=DoubleToStr(subvalue_double1*10, 12);
         string subvalue2=StringSubstr(value2, 2, 12);
         string subvalue2chop=StringSubstr(value2, 0, 1);
         int subvalue2chop2dble=StrToDouble(subvalue2chop);
            double subvalue_double2=StrToDouble(subvalue2)/100000000;
            
       string value3=DoubleToStr(subvalue_double2*10, 12);
         string subvalue3=StringSubstr(value3, 2, 12);
         string subvalue3chop=StringSubstr(value3, 0, 1);
         int subvalue3chop2dble=StrToDouble(subvalue3chop);
            double subvalue_double3=StrToDouble(subvalue3)/100000000;
            
       string value4=DoubleToStr(subvalue_double3*10, 12);
         string subvalue4=StringSubstr(value4, 2, 12);
         string subvalue4chop=StringSubstr(value4, 0, 1);
         int subvalue4chop2dble=StrToDouble(subvalue4chop);
            double subvalue_double4=StrToDouble(subvalue4)/100000000;                     
       
       string value5=DoubleToStr(subvalue_double4*10, 12);
         string subvalue5=StringSubstr(value5, 2, 12);
         string subvalue5chop=StringSubstr(value5, 0, 1);
         int subvalue5chop2dble=StrToDouble(subvalue5chop);
            double subvalue_double5=StrToDouble(subvalue5)/100000000; 

       string value6=DoubleToStr(subvalue_double5*10, 12);
         string subvalue6=StringSubstr(value6, 2, 12);
         string subvalue6chop=StringSubstr(value6, 0, 1);
         int subvalue6chop2dble=StrToDouble(subvalue6chop);
            double subvalue_double6=StrToDouble(subvalue6)/100000000;

       string value7=DoubleToStr(subvalue_double6*10, 12);
         string subvalue7=StringSubstr(value7, 2, 12);
         string subvalue7chop=StringSubstr(value7, 0, 1);
         int subvalue7chop2dble=StrToDouble(subvalue7chop);
            double subvalue_double7=StrToDouble(subvalue7)/100000000; 
            
       string value8=DoubleToStr(subvalue_double7*10, 12);
         string subvalue8=StringSubstr(value8, 2, 12);
         string subvalue8chop=StringSubstr(value8, 0, 1);
         int subvalue8chop2dble=StrToDouble(subvalue8chop);
            double subvalue_double8=StrToDouble(subvalue8)/100000000; 
                       
       string value9=DoubleToStr(subvalue_double8*10, 12);
         string subvalue9=StringSubstr(value9, 2, 12);
         string subvalue9chop=StringSubstr(value9, 0, 1);
         int subvalue9chop2dble=StrToDouble(subvalue9chop);
            double subvalue_double9=StrToDouble(subvalue9)/100000000;
            
       if(subvalue0chop2dble==0)subvalue_double0=subvalue_double0; 
       if(subvalue0chop2dble==1)subvalue_double0=subvalue_double0*0.7;
       if(subvalue0chop2dble==2)subvalue_double0=subvalue_double0*0.4;
       if(subvalue0chop2dble==3)subvalue_double0= -subvalue_double0*0.4;
       if(subvalue0chop2dble==4)subvalue_double0= -subvalue_double0*0.9;
       if(subvalue0chop2dble==5)subvalue_double0= -subvalue_double0;
       if(subvalue0chop2dble==6)subvalue_double0= -subvalue_double0*0.9;
       if(subvalue0chop2dble==7)subvalue_double0= -subvalue_double0*0.4;
       if(subvalue0chop2dble==8)subvalue_double0= -subvalue_double0*0.4;
       if(subvalue0chop2dble==9)subvalue_double0=subvalue_double0*0.7;

       if(subvalue1chop2dble==0)subvalue_double1=subvalue_double1; 
       if(subvalue1chop2dble==1)subvalue_double1=subvalue_double1*0.7;
       if(subvalue1chop2dble==2)subvalue_double1=subvalue_double1*0.4;
       if(subvalue1chop2dble==3)subvalue_double1= -subvalue_double1*0.4;
       if(subvalue1chop2dble==4)subvalue_double1= -subvalue_double1*0.9;
       if(subvalue1chop2dble==5)subvalue_double1= -subvalue_double1;
       if(subvalue1chop2dble==6)subvalue_double1= -subvalue_double1*0.9;
       if(subvalue1chop2dble==7)subvalue_double1= -subvalue_double1*0.4;
       if(subvalue1chop2dble==8)subvalue_double1= -subvalue_double1*0.4;
       if(subvalue1chop2dble==9)subvalue_double1=subvalue_double1*0.7; 

       if(subvalue2chop2dble==0)subvalue_double2=subvalue_double2; 
       if(subvalue2chop2dble==1)subvalue_double2=subvalue_double2*0.7;
       if(subvalue2chop2dble==2)subvalue_double2=subvalue_double2*0.4;
       if(subvalue2chop2dble==3)subvalue_double2= -subvalue_double2*0.4;
       if(subvalue2chop2dble==4)subvalue_double2= -subvalue_double2*0.9;
       if(subvalue2chop2dble==5)subvalue_double2= -subvalue_double2;
       if(subvalue2chop2dble==6)subvalue_double2= -subvalue_double2*0.9;
       if(subvalue2chop2dble==7)subvalue_double2= -subvalue_double2*0.4;
       if(subvalue2chop2dble==8)subvalue_double2= -subvalue_double2*0.4;
       if(subvalue2chop2dble==9)subvalue_double2=subvalue_double2*0.7;     
       

       if(subvalue3chop2dble==0)subvalue_double3=subvalue_double3; 
       if(subvalue3chop2dble==1)subvalue_double3=subvalue_double3*0.7;
       if(subvalue3chop2dble==2)subvalue_double3=subvalue_double3*0.4;
       if(subvalue3chop2dble==3)subvalue_double3= -subvalue_double3*0.4;
       if(subvalue3chop2dble==4)subvalue_double3= -subvalue_double3*0.9;
       if(subvalue3chop2dble==5)subvalue_double3= -subvalue_double3;
       if(subvalue3chop2dble==6)subvalue_double3= -subvalue_double3*0.9;
       if(subvalue3chop2dble==7)subvalue_double3= -subvalue_double3*0.4;
       if(subvalue3chop2dble==8)subvalue_double3= -subvalue_double3*0.4;
       if(subvalue3chop2dble==9)subvalue_double3=subvalue_double3*0.7;       

       

       if(subvalue4chop2dble==0)subvalue_double4=subvalue_double4; 
       if(subvalue4chop2dble==1)subvalue_double4=subvalue_double4*0.7;
       if(subvalue4chop2dble==2)subvalue_double4=subvalue_double4*0.4;
       if(subvalue4chop2dble==3)subvalue_double4= -subvalue_double4*0.4;
       if(subvalue4chop2dble==4)subvalue_double4= -subvalue_double4*0.9;
       if(subvalue4chop2dble==5)subvalue_double4= -subvalue_double4;
       if(subvalue4chop2dble==6)subvalue_double4= -subvalue_double4*0.9;
       if(subvalue4chop2dble==7)subvalue_double4= -subvalue_double4*0.4;
       if(subvalue4chop2dble==8)subvalue_double4= -subvalue_double4*0.4;
       if(subvalue4chop2dble==9)subvalue_double4=subvalue_double4*0.7;

       if(subvalue5chop2dble==0)subvalue_double5= subvalue_double5; 
       if(subvalue5chop2dble==1)subvalue_double5= subvalue_double5*0.7;
       if(subvalue5chop2dble==2)subvalue_double5= subvalue_double5*0.4;
       if(subvalue5chop2dble==3)subvalue_double5= -subvalue_double5*0.4;
       if(subvalue5chop2dble==4)subvalue_double5= -subvalue_double5*0.9;
       if(subvalue5chop2dble==5)subvalue_double5= -subvalue_double5;
       if(subvalue5chop2dble==6)subvalue_double5= -subvalue_double5*0.9;
       if(subvalue5chop2dble==7)subvalue_double5= -subvalue_double5*0.4;
       if(subvalue5chop2dble==8)subvalue_double5= -subvalue_double5*0.4;
       if(subvalue5chop2dble==9)subvalue_double5= subvalue_double5*0.7;


       if(subvalue6chop2dble==0)subvalue_double6= subvalue_double6; 
       if(subvalue6chop2dble==1)subvalue_double6= subvalue_double6*0.7;
       if(subvalue6chop2dble==2)subvalue_double6= subvalue_double6*0.4;
       if(subvalue6chop2dble==3)subvalue_double6= -subvalue_double6*0.4;
       if(subvalue6chop2dble==4)subvalue_double6= -subvalue_double6*0.9;
       if(subvalue6chop2dble==5)subvalue_double6= -subvalue_double6;
       if(subvalue6chop2dble==6)subvalue_double6= -subvalue_double6*0.9;
       if(subvalue6chop2dble==7)subvalue_double6= -subvalue_double6*0.4;
       if(subvalue6chop2dble==8)subvalue_double6= -subvalue_double6*0.4;
       if(subvalue6chop2dble==9)subvalue_double6= subvalue_double6*0.7;


       if(subvalue7chop2dble==0)subvalue_double7= subvalue_double7; 
       if(subvalue7chop2dble==1)subvalue_double7= subvalue_double7*0.7;
       if(subvalue7chop2dble==2)subvalue_double7= subvalue_double7*0.4;
       if(subvalue7chop2dble==3)subvalue_double7= -subvalue_double7*0.4;
       if(subvalue7chop2dble==4)subvalue_double7= -subvalue_double7*0.9;
       if(subvalue7chop2dble==5)subvalue_double7= -subvalue_double7;
       if(subvalue7chop2dble==6)subvalue_double7= -subvalue_double7*0.9;
       if(subvalue7chop2dble==7)subvalue_double7= -subvalue_double7*0.4;
       if(subvalue7chop2dble==8)subvalue_double7= -subvalue_double7*0.4;
       if(subvalue7chop2dble==9)subvalue_double7= subvalue_double7*0.7;
       

       if(subvalue8chop2dble==0)subvalue_double8= subvalue_double8; 
       if(subvalue8chop2dble==1)subvalue_double8= subvalue_double8*0.7;
       if(subvalue8chop2dble==2)subvalue_double8= subvalue_double8*0.4;
       if(subvalue8chop2dble==3)subvalue_double8= -subvalue_double8*0.4;
       if(subvalue8chop2dble==4)subvalue_double8= -subvalue_double8*0.9;
       if(subvalue8chop2dble==5)subvalue_double8= -subvalue_double8;
       if(subvalue8chop2dble==6)subvalue_double8= -subvalue_double8*0.9;
       if(subvalue8chop2dble==7)subvalue_double8= -subvalue_double8*0.4;
       if(subvalue8chop2dble==8)subvalue_double8= -subvalue_double8*0.4;
       if(subvalue8chop2dble==9)subvalue_double8= subvalue_double8*0.7; 
       

       if(subvalue9chop2dble==0)subvalue_double9= subvalue_double9; 
       if(subvalue9chop2dble==1)subvalue_double9= subvalue_double9*0.7;
       if(subvalue9chop2dble==2)subvalue_double9= subvalue_double9*0.4;
       if(subvalue9chop2dble==3)subvalue_double9= -subvalue_double9*0.4;
       if(subvalue9chop2dble==4)subvalue_double9= -subvalue_double9*0.9;
       if(subvalue9chop2dble==5)subvalue_double9= -subvalue_double9;
       if(subvalue9chop2dble==6)subvalue_double9= -subvalue_double9*0.9;
       if(subvalue9chop2dble==7)subvalue_double9= -subvalue_double9*0.4;
       if(subvalue9chop2dble==8)subvalue_double9= -subvalue_double9*0.4;
       if(subvalue9chop2dble==9)subvalue_double9= subvalue_double9*0.7;       
       
       
                                                           
        double cx[10];
        
        cx[0]=subvalue_double0;
        cx[1]=subvalue_double1;
        cx[2]=subvalue_double2;
        cx[3]=subvalue_double3;
        cx[4]=subvalue_double4;
        cx[5]=subvalue_double5;
        cx[6]=subvalue_double6;
        cx[7]=subvalue_double7;
        cx[8]=subvalue_double8;
        cx[9]=subvalue_double9;

         main_data[i]=iClose(NULL,0,i+0)+
         (
          (iClose(NULL,0,i+0)*cx[subvalue0chop2dble])
         +(iClose(NULL,0,i+1)*cx[subvalue1chop2dble])
         +(iClose(NULL,0,i+2)*cx[subvalue2chop2dble])
         +(iClose(NULL,0,i+3)*cx[subvalue3chop2dble])
         +(iClose(NULL,0,i+4)*cx[subvalue4chop2dble])
         +(iClose(NULL,0,i+5)*cx[subvalue5chop2dble])
         +(iClose(NULL,0,i+6)*cx[subvalue6chop2dble])
         +(iClose(NULL,0,i+7)*cx[subvalue7chop2dble])
         +(iClose(NULL,0,i+8)*cx[subvalue8chop2dble])
         +(iClose(NULL,0,i+9)*cx[subvalue9chop2dble]))
         /1000;

         
         
         
         
       }
     for(i=0; i<limit; i++)
       {
       smooth_line[i]=iMAOnArray(main_data,0,Smooth_Period,0,MODE_LWMA,i);
       
       }
  //---- done
     return(0);
    }
//+------------------------------------------------------------------+